Imports System.EnterpriseServices
Imports System.Runtime.CompilerServices
Imports System.Reflection
Imports TransactionDemoDataAccess

' Supply the COM+ application name. 
<Assembly: ApplicationName("SalesComponent")> 
' Supply a strong-named assembly.
<Assembly: AssemblyKeyFileAttribute("..\..\TransDemo.snk")> 

<Transaction(TransactionOption.Required)> _
 Public Class AutomaticSalesComponent
    Inherits ServicedComponent
    Implements ISalesComponent

    Public Function MakeSale(ByVal connectionString As String, ByVal customerID As String, ByVal productID As Integer, _
      ByVal requestedQty As Integer, ByVal unitPrice As Double, ByVal discount As Double) As Boolean Implements ISalesComponent.MakeSale

        Dim conn As New SqlClient.SqlConnection
        Dim successfulSale As Boolean
        Dim dataAccess As New DataAccess

        Try

            conn.ConnectionString = connectionString
            conn.Open()

            ' attempt to add a new order. if this fails newOrder 
            ' method will return false and transaction will be rolled back
            successfulSale = dataAccess.newOrder(conn, customerID, productID, requestedQty, unitPrice, discount)

            If successfulSale Then

                ' attempt to adjust inventory, if this fails, adjustInventory 
                ' method will return false and transaction will be rolled back
                successfulSale = dataAccess.adjustInventory(conn, requestedQty, productID)

                If successfulSale Then

                    ' check credit card limit. if over limit rollback transaction
                    successfulSale = dataAccess.checkCreditCard()

                End If

            End If

            If successfulSale Then

                ' if the sale is successful, commit the transaction
                ContextUtil.SetComplete()

            Else

                ' if some part of the sale was unsuccessful (the credit card check), 
                ' rollback the transaction
                ContextUtil.SetAbort()
                successfulSale = False

            End If

        Catch ex As Exception

            ' If an error occurs, rollback transaction
            ContextUtil.SetAbort()
            Throw ex

        Finally

            ' if the connection is still open (possibly from an error) close the connection here.
            If conn.State = ConnectionState.Open Then
                conn.Close()
            End If

            MakeSale = successfulSale

        End Try

    End Function

End Class