using System;
using System.Data;
using System.Data.SqlClient;
using DataAccess;

namespace BusinessLogic
{
	/// <summary>
	/// Summary description for ManualSalesComponent.
	/// </summary>
	public class ManualSalesComponent : ISalesComponent
	{
		public ManualSalesComponent()
		{
			//
			// TODO: Add constructor logic here
			//
		}

		public bool MakeSale(string connectionString, string customerID, int productID, int requestedQty, double unitPrice, double discount)
		{
			SqlConnection conn = new SqlConnection();
			bool successfulSale;
			DataAccess.DataAccess dataAccess = new DataAccess.DataAccess();
			SqlTransaction trans;

			conn.ConnectionString = connectionString;
			conn.Open();

			// return a transaction object from the opened connection
			trans = conn.BeginTransaction();

			try 
			{

				successfulSale = dataAccess.newOrder(conn, trans, customerID, productID, requestedQty, unitPrice, discount);

				if (successfulSale) 
				{

					successfulSale = dataAccess.adjustInventory(conn, trans, requestedQty, productID);

					if (successfulSale) 

						// check credit card limit. if over limit rollback transaction
						successfulSale = dataAccess.checkCreditCard();

				}			

				if (successfulSale)

					// All operations were successful, commit changes
					trans.Commit();

				else 
				{

					trans.Rollback();
					successfulSale = false;

				}

				return successfulSale;
			}
			catch(Exception ex)
			{

				// If an error occurs, rollback transaction
				trans.Rollback();
				return false;
				throw ex;

			}

			finally 
			{

				trans.Dispose();

				if (conn.State == ConnectionState.Open) 
					conn.Close();

			}
		}
	}
}
