using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Diagnostics;
using System.Web;
using System.Web.Services;
using System.EnterpriseServices;
using DataAccess;

namespace TransactionDemoCSharpWebService
{
	/// <summary>
	/// Summary description for SalesComponentWeb.
	/// </summary>
	public class SalesComponentWeb : System.Web.Services.WebService
	{
		public SalesComponentWeb()
		{
			//CODEGEN: This call is required by the ASP.NET Web Services Designer
			InitializeComponent();
		}

		#region Component Designer generated code
		
		//Required by the Web Services Designer 
		private IContainer components = null;
				
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if(disposing && components != null)
			{
				components.Dispose();
			}
			base.Dispose(disposing);		
		}
		
		#endregion


		[WebMethod(TransactionOption=TransactionOption.RequiresNew)] 
		public bool MakeSale(string connectionString, string customerID, int productID, int requestedQty, 
			double unitPrice, double discount) 
		{

			SqlConnection conn = new SqlConnection();
			bool successfulSale;
			DataAccess.DataAccess dataAccess = new DataAccess.DataAccess();

			try 
			{

				conn.ConnectionString = connectionString;
				conn.Open();

				// attempt to add a new order. if this fails newOrder 
				// method will return false and transaction will be rolled back
				successfulSale = dataAccess.newOrder(conn, customerID, productID, requestedQty, unitPrice, discount);

				if (successfulSale) 
				{

					// attempt to adjust inventory, if this fails, adjustInventory 
					// method will return false and transaction will be rolled back
					successfulSale = dataAccess.adjustInventory(conn, requestedQty, productID);

					if (successfulSale)

						// check credit card limit. if over limit rollback transaction
						successfulSale = dataAccess.checkCreditCard();


				}
				if (successfulSale)

					// if the sale is successful, commit the transaction
					ContextUtil.SetComplete();

				else 
				{

					// if some part of the sale was unsuccessful (the credit card check), 
					// rollback the transaction
					ContextUtil.SetAbort();
					successfulSale = false;

				}

				return successfulSale;
			}
			catch (Exception ex) 
			{

				// If an error occurs, rollback transaction
				ContextUtil.SetAbort();
				throw ex;
			}

			finally 
			{

				if (conn.State == ConnectionState.Open)
					conn.Close();

			}

		}

	}
}
